#include <Keypad.h>
#include <Servo.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

char* password = "888";
int position = 0;
const byte ROWS = 4;
const byte COLS = 4;
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

byte rowPins[ROWS] = {9, 8, 7 ,6};
byte colPins[COLS] = {5, 4, 3, 2};
Keypad keypad = Keypad(makeKeymap(keys), rowPins, colPins, ROWS, COLS);

Servo servoMotor;
const int servoPin = 11;
const int openPosition = 180;

int counterIncorrectPassword = 0;

LiquidCrystal_I2C lcd(0x27,20,4); // I2C address may vary, adjust accordingly
bool retrimit = false;
int count_ = 0;
ISR(TIMER2_COMPA_vect){
  //  Serial.println()
  if (retrimit){
    count_ ++;
    if (count_ > 2000){
      retrimit = false;
      Serial.println("Blocked");
    }
  }
}
 
void setup() {
  Serial.begin(9600); // Initialize serial communication
  lcd.init();                      // initialize the lcd 
  lcd.init();
  lcd.backlight();
  lcd.print("Enter password");
  lcd.setCursor(0, 1);
  lcd.print("PIN:");
  servoMotor.attach(servoPin);  // Attach the servo to the specified pin
  servoMotor.write(0); 
  cli(); // stop interrupts
  TCCR2A = 0; // set entire TCCR2A register to 0
  TCCR2B = 0; // same for TCCR2B
  TCNT2  = 0; // initialize counter value to 0
  // set compare match register for 1000 Hz increments
  OCR2A = 249; // = 16000000 / (64 * 1000) - 1 (must be <256)
  // turn on CTC mode
  TCCR2B |= (1 << WGM21);
  // Set CS22, CS21 and CS20 bits for 64 prescaler
  TCCR2B |= (1 << CS22) | (0 << CS21) | (0 << CS20);
  // enable timer compare interrupt
  TIMSK2 |= (1 << OCIE2A);
  sei(); // allow interrupts
}
bool flag = true;
bool doorBlockedFlag = false;
void loop() {
  // Serial.println("ASDASDASDASD");
  // put your main code here, to run repeatedly:
  char key = keypad.getKey(); // Read the pressed key
  if(counterIncorrectPassword > 2){
    // Serial.println("incorect");
    if (Serial.available() > 0) {
    String data = Serial.readString();  // Read the data from the serial port
    if(strcmp(data.c_str(),"Unblock") == 0){
      doorBlockedFlag = false;
      counterIncorrectPassword = 0;
      lcd.clear(); // Clear the LCD after displaying the message
      lcd.print("Enter password");
      lcd.setCursor(0, 1);
      lcd.print("PIN:");
      return;
    }
    if(strcmp(data.c_str(),"Block") == 0){
      retrimit = true;
      return;
    }
  }
    if(!doorBlockedFlag){
      // Serial.println("blocked");
      lcd.clear(); // Clear the LCD
      lcd.print("Blocked");
      Serial.println("Blocked");
      doorBlockedFlag = true;
    }
    return;
  }

  if (key) { // If a key is pressed
    Serial.println(key); // Print the pressed key to the console
    lcd.setCursor(position + 4, 1); // Set the LCD cursor position for number input
    lcd.print("*"); // Print the pressed key on the LCD
    
    if (key == password[position] && flag) {
      position++;
      flag = flag && true;
      if (position == 3) {
        position = 0; // Call the function to rotate the servo motor
        delay(1000);
        lcd.clear(); // Clear the LCD
        lcd.print("Door open");
        openDoor(); // Display "Door open" message on the LCD
        lcd.clear(); // Clear the LCD after displaying the message
        lcd.print("Enter password");
        lcd.setCursor(0, 1);
        lcd.print("PIN:");
        counterIncorrectPassword = 0;
      }
    } else {
      position++;
      flag = flag && false;
      if (position == 3) {
        position = 0;
        delay(1000);
        lcd.clear(); // Clear the LCD
        lcd.print("Incorrect"); // Display "Incorrect" message on the LCD
        delay(2000); // Display the message for 2 seconds
        lcd.clear(); // Clear the LCD after displaying the message
        lcd.print("Enter password");
        lcd.setCursor(0, 1);
        lcd.print("PIN:");
        flag = true;
        counterIncorrectPassword++;
      }
    }
  }
}

void openDoor() {
  servoMotor.write(openPosition);  // Rotate the servo to the desired position
  delay(5000);  // Wait for 1 second
  servoMotor.write(0);  // Return the servo to the initial position (if needed)
}
